clc;clear all;%close all
addpath('../datafiles')
load('ReykjanesStationsActive.mat');% in spherical coordinate
% project station location into the UTM coordinate
% p = projcrs(3055);%Hjorsey 1955 / UTM zone 27N, Topographic mapping (1:50,000) published between 1955 and 2000
p = projcrs(32227);% WGS 72 / UTM zone 27N
[Easting,Northing] = projfwd(p,LatLong(:,1),LatLong(:,2)); % Project latitude-longitude coordinates to x-y map coordinates
figure('Position',get(0,'screensize'))
twoaxis=1;
if twoaxis==1
    % define a background axis to define on it the UTM coordinate
    ax1=axes('Box','off');
    set(ax1,'BoxStyle','full','TickDir','out','XAxisLocation','top','YAxisLocation','right');
    xlabel('Easting (km)');ylabel('Northing (km)')
end
ax2=geoaxes;
h0=geoplot(ax2,LatLong(:,1),LatLong(:,2),'MarkerSize',10,'Marker','v','MarkerEdgeColor','r','MarkerFaceColor','none','LineStyle','none','LineWidth',2);
hold on
% fileID1 = fopen('activestations.dat','w');
% fprintf(fileID1,'%d %d\n',size(LatLong,1),2);
% for i=1:size(LatLong,1)
%     fprintf(fileID1,'%d %d\n',LatLong(i,1),LatLong(i,2));
% end

%% Loading and plotting geological settings
% Volcanic systems
load('VolcanicSystems.mat')% in spherical coordinate
%     load('data/Lake.mat')% in spherical coordinate
%     hold on;h=geoplot(ax2,LakeLat,LakeLon,'b','LineStyle','-','LineWidth',3);
for i=1:length(S)-1
    hold on;h1(i)=geoplot(ax2,S(i).Y,S(i).X,'y','LineStyle','-','LineWidth',3);
end
% High temperature zones
load('HTzones.mat')
for i=1:length(S)
    hold on;h2(i)=geoplot(ax2,S(i).Y,S(i).X,'k:','LineStyle',':','LineWidth',3);
end
%% Legends
% Create column vector of plot handles
h=[h0;h1(1);h2(1)];
% Now call the legend function passing the handle h and specify the text
legend(h,'Seismic stations','Volcanic systems','High-temperature zones','Location','southeast');

set(ax2,'Fontsize',16,'FontWeight','bold')
grid on
box on
addCustomBasemap('googleSat','https://mt1.google.com/vt/lyrs=s&x={x}&y={y}&z={z}')
geobasemap(ax2,'googleSat')
% geobasemap(ax2,'topographic')
% geobasemap(ax2,'colorterrain')
% geobasemap(ax2,'darkwater')
% geobasemap(ax2,'openstreetmap')
% geobasemap(ax2,'bluegreen')
% geobasemap(ax2,'streets-light')
% geobasemap(ax2,'opentopomap')
%% Second axis: to show the UTM coordinates on other axis for reference
if twoaxis==1% defining UTM axis
    set(ax1,'Fontsize',16,'FontWeight','bold')
    lonlim=[-24 -21.7];latlim=[63.4641   64.1365];
    geolimits(latlim,lonlim)
    [latitudeLimits,longitudeLimits] = geolimits;
    p = projcrs(32227);% WGS 72 / UTM zone 27N
    [E,N] = projfwd(p,latitudeLimits,longitudeLimits); % Project latitude-longitude coordinates to x-y map coordinates
    xlim(ax1,E/1000)
    ylim(ax1,N/1000)
end
saveas(gcf,'Figure1.png')


% % %% Adding location of active powerplants
% % PowerPlantsLatLong=[63.879 -22.433;63.825 -22.685];
% % ReferencePoints=sortrows(PowerPlantsLatLong,1);
% % plotreferencepoints=0;
% % % ReferencePoints=ReferencePoints(2:5,:);
% % if plotreferencepoints==1
% %     hold on;geoplot(ax2,ReferencePoints(:,1),ReferencePoints(:,2),'MarkerFaceColor','none','MarkerEdgeColor','k','MarkerSize',20,'Marker','.','LineStyle','none','LineWidth',3)
% %     for ii=1:size(ReferencePoints,1)
% %         % text(ReferencePoints(ii,1),ReferencePoints(ii,2),['\leftarrow ',num2str(ii)])
% %         text(ax2,ReferencePoints(ii,1),ReferencePoints(ii,2),num2str(ii),'HorizontalAlignment', 'right')
% %         % textm(ReferencePoints(ii,1),ReferencePoints(ii,2),num2str(ii))
% %     end
% % end
