% Comparing our result with Hersir et el (2020)
clc;clear;close all
addpath('../datafiles')
addpath('Functions')
load('stdS_Vsmean.mat');

caxislim=[2.3 4];
displaylimx=[-0.5 12.5];
cmp = colormap(jet(50));
cmp = flipud(cmp);

% displaylimitx=[-22.9 -21.9];
% displaylimity=[63.7 64.05];

Section_coordinates = [-22.150382 63.956427 ;-22.009706 63.868111;...%section 1
                       -22.122111 63.972346 ;-21.981443 63.884002];  %section 2
inputparameters;
% [xutm1,yutm1]=utmxy(x,y);
zmaxview=4;
nz=find(z>=zmaxview,1);
p = projcrs(32227);% WGS 72 / UTM zone 27N
% Project latitude-longitude coordinates to x-y map coordinates
%[x,y] = projfwd(proj,lat,lon)
[E,N] = projfwd(p,Section_coordinates(:,2),Section_coordinates(:,1)); 
[X,Y,Z]=meshgrid(x,y,z);

Referencepoints_utm(:,1)=E/1000;
Referencepoints_utm(:,2)=N/1000;
%% section 1
% x0=Referencepoints_utm(1,1);
% y0=Referencepoints_utm(1,2);
% x1=Referencepoints_utm(2,1);
% y1=Referencepoints_utm(2,2);
x0=Section_coordinates(1,1);
y0=Section_coordinates(1,2);
x1=Section_coordinates(2,1);
y1=Section_coordinates(2,2);
ymin=min(Section_coordinates(1:2,2));
ymax=max(Section_coordinates(1:2,2));
[Xslice,Yslice,Zslice,xslice,yslice]=deviatedslicelocation2points(x,z,x0,y0,x1,y1,ymax,ymin);
ss=slice(X(:,:,1:nz),Y(:,:,1:nz),Z(:,:,1:nz),Vsmean(:,:,1:nz),Xslice(1:nz,:),Yslice(1:nz,:),Zslice(1:nz,:));
section1=ss.CData;
xs1=ss.XData(1,:);
ys1=ss.YData(1,:);
zs1=ss.ZData(:,1);
[E,N] = projfwd(p,ys1,xs1); 
xs11=E/1000;
ys11=N/1000;
distanc0=sqrt((ys11(1)-Referencepoints_utm(1,2)).^2+(xs11(1)-Referencepoints_utm(1,1)).^2);
xsection1=sqrt((ys11-ys11(1)).^2+(xs11-xs11(1)).^2)-distanc0;

% xsection1=sqrt((ys11-Referencepoints_utm(1,2)).^2+(xs11-Referencepoints_utm(1,1)).^2);
% xsection1(1)=-xsection1(1);
figure(111);
plot(xs1,ys1,'k')
hold on;plot([x0 x1],[y0 y1],'k','LineStyle','none','Marker','p')

% section 2
% x0=Referencepoints_utm(3,1);
% y0=Referencepoints_utm(3,2);
% x1=Referencepoints_utm(4,1);
% y1=Referencepoints_utm(4,2);
x0=Section_coordinates(3,1);
y0=Section_coordinates(3,2);
x1=Section_coordinates(4,1);
y1=Section_coordinates(4,2);
ymin=min(Section_coordinates(3:4,2));
ymax=max(Section_coordinates(3:4,2));
[Xslice2,Yslice2,Zslice2,xslice2,yslice2]=deviatedslicelocation2points(x,z,x0,y0,x1,y1,ymax,ymin);
ss=slice(X(:,:,1:nz),Y(:,:,1:nz),Z(:,:,1:nz),Vsmean(:,:,1:nz),Xslice2(1:nz,:),Yslice2(1:nz,:),Zslice2(1:nz,:));
section2=ss.CData;
xs2=ss.XData(1,:);
ys2=ss.YData(1,:);
zs2=ss.ZData(:,1);
[E,N] = projfwd(p,ys2,xs2);
xs22=E/1000;
ys22=N/1000;
% xsection2=sqrt((ys22-Referencepoints_utm(3,2)).^2+(xs22-Referencepoints_utm(3,1)).^2);
% xsection2(1)=-xsection2(1);
distanc0=sqrt((ys22(1)-Referencepoints_utm(3,2)).^2+(xs22(1)-Referencepoints_utm(3,1)).^2);
xsection2=sqrt((ys22-ys22(1)).^2+(xs22-xs22(1)).^2)-distanc0;

figure(111);
plot(xs2,ys2,'b')
hold on;plot([x0 x1],[y0 y1],'b','LineStyle','none','Marker','p')

%%


figure;
pcolor(xsection1,zs1*1000,section1);colorbar;colormap(jet);
axis ij;set(gca,'YDir','reverse','XDir','normal')
shading flat;shading interp
zlim([0 4])
% title('(c)');
xlabel('Distance (km)');
% ylabel('Depth (m)')
% cb=colorbar;
% cb.Label.String='Shear wave velocity (km/s)';
box(gca,'on');
set(gca,'FontSize',16,'FontWeight','bold','LineWidth',2,'TickDir','out')
% Create colorbar
colorbar(gca,'Position',...
    [0.91922738031721 0.111111111111111 0.0175592746432818 0.738011695906433]);

% Create textbox
annotation(gcf,'textbox',...
    [0.898040010033864 0.89185463659148 0.0610184372256364 0.0374269005847954],...
    'String',{'km/s'},...
    'LineStyle','none',...
    'FontWeight','bold',...
    'FontSize',18,...
    'FitBoxToText','off');

set(gca,'FontSize',16,'FontWeight','bold')
colormap(cmp);
% clim(caxislim);
xlim(displaylimx)
exportgraphics(gcf,'Figure10c.png');
saveas(gcf,'Figure10c.fig')
%% second section
[E,N] = projfwd(p,ys2,xs2); 


figure;
pcolor(xsection2,zs2*1000,section2);colorbar;
colormap(cmp);
axis ij;set(gca,'YDir','reverse','XDir','normal')
shading flat;shading interp
zlim([0 4])
% title('(d)');
xlabel('Distance (km)');
% ylabel('Depth (m)')
% cb=colorbar;
% cb.Label.String='Shear wave velocity (km/s)';
box(gca,'on');
set(gca,'FontSize',16,'FontWeight','bold','LineWidth',2,'TickDir','out')

% Create colorbar
colorbar(gca,'Position',...
    [0.91922738031721 0.111111111111111 0.0175592746432818 0.738011695906433]);

% Create textbox
annotation(gcf,'textbox',...
    [0.898040010033864 0.89185463659148 0.0610184372256364 0.0374269005847954],...
    'String',{'km/s'},...
    'LineStyle','none',...
    'FontWeight','bold',...
    'FontSize',18,...
    'FitBoxToText','off');
set(gca,'FontSize',16,'FontWeight','bold')
clim(caxislim)
xlim(displaylimx)
exportgraphics(gcf,'Figure10d.png');
saveas(gcf,'Figure10d.fig')

%% ploting section location on a reference map
figure(111);
xlbl='Longitude';
ylbl='Latitude';
displaylimitx=[-22.8 -21.9];
displaylimity=[63.75 64.05];
plot(xs1,ys1,'b','LineWidth',3)
hold on
plot(xs2,ys2,'b','LineWidth',3)
load('Reykjanes_Coastline_latlong.mat');% Reading coast line data
CoastX=CoastLonlat(:,1);CoastY=CoastLonlat(:,2);
xlabel(xlbl);ylabel(ylbl);
title('(a)')
set(gca,'YDir','normal')
hold on;plot(CoastX,CoastY,'k','LineWidth',2)
xlim(displaylimitx);ylim(displaylimity);
clim(caxislim)
load('HTzones.mat')
for i=1:length(S)
   hold on;h=plot(gca,S(i).X,S(i).Y,'k','LineStyle',':','LineWidth',3); 
end

p = projcrs(32227);% WGS 72 / UTM zone 27N
[E,N] = projfwd(p,displaylimity,displaylimitx); % Project latitude-longitude coordinates to x-y map coordinates
latrange=abs(diff(displaylimity));
lonrange=abs(diff(displaylimitx));
xrange=abs(diff(E))/1000;
yrange=abs(diff(N))/1000;
daspect(gca,[lonrange/xrange latrange/yrange 1]);
exportgraphics(gcf,'FigureS5.png');saveas(gcf,'FigureS5.fig')
