% Comparing our result with Hersir et el (2020)
clc;clear;close all
addpath('../datafiles')
addpath('Functions')
load('stdS_Vsmean.mat');

% caxislim=[2. 4.2];
displaylimx=[-3.5 3.5];
cmp = colormap(jet(40));
cmp = flipud(cmp);
colormap(cmp)
% displaylimitx=[-22.9 -21.9];
% displaylimity=[63.7 64.05];

Section_coordinates_all = [
-22.76963045 63.84280699	%038EW_N-3875
-22.62255444 63.79116207	%038EW_N-3875
-22.76016202 63.84808267	%041EW_N-3125
-22.61307374 63.79642801	%041EW_N-3125
-22.75383684 63.85159404	%043EW_N-2625
-22.60674190 63.79993373	%043EW_N-2625
-22.75067735 63.85335447	%044EW_N-2375
-22.60358282 63.80168900];	%044EW_N-2375
Section_coordinates=Section_coordinates_all([3:6],:);
inputparameters;
% [xutm,yutm]=utmxy();
p = projcrs(32227);% WGS 72 / UTM zone 27N
% Project latitude-longitude coordinates to x-y map coordinates
%[x,y] = projfwd(proj,lat,lon)
[E,N] = projfwd(p,Section_coordinates(:,2),Section_coordinates(:,1)); 
[X,Y,Z]=meshgrid(x,y,z);

Referencepoints_utm(:,1)=E/1000;
Referencepoints_utm(:,2)=N/1000;
%% section 1
% x0=Referencepoints_utm(1,1);
% y0=Referencepoints_utm(1,2);
% x1=Referencepoints_utm(2,1);
% y1=Referencepoints_utm(2,2);
x0=Section_coordinates(1,1);
y0=Section_coordinates(1,2);
x1=Section_coordinates(2,1);
y1=Section_coordinates(2,2);
ymin=min(Section_coordinates(1:2,2));
ymax=max(Section_coordinates(1:2,2));
[Xslice,Yslice,Zslice,xslice,yslice]=deviatedslicelocation2points(x,z,x0,y0,x1,y1,ymax,ymin);

% nzd=6/0.25+1;
zmaxview=6;
nzd=find(z>=zmaxview,1);
ss=slice(X(:,:,1:nzd),Y(:,:,1:nzd),Z(:,:,1:nzd),Vsmean(:,:,1:nzd),Xslice(1:nzd,:),Yslice(1:nzd,:),Zslice(1:nzd,:));

section1=ss.CData;
xs1=ss.XData(1,:);
ys1=ss.YData(1,:);
zs1=ss.ZData(:,1);
[E,N] = projfwd(p,ys1,xs1); 
xs11=E/1000;
ys11=N/1000;
y0=(Referencepoints_utm(1,2)+Referencepoints_utm(2,2))/2;
x0=(Referencepoints_utm(1,1)+Referencepoints_utm(2,1))/2;
distanc0=sqrt((ys11(1)-y0).^2+(xs11(1)-x0).^2);
xsection1=sqrt((ys11-ys11(1)).^2+(xs11-xs11(1)).^2)-distanc0;

% xsection1=sqrt((ys11-Referencepoints_utm(1,2)).^2+(xs11-Referencepoints_utm(1,1)).^2);
% xsection1(1)=-xsection1(1);
figure(111);
plot(xs1,ys1,'k')
hold on;plot([x0 x1],[y0 y1],'k','LineStyle','none','Marker','p')

% section 2
% x0=Referencepoints_utm(3,1);
% y0=Referencepoints_utm(3,2);
% x1=Referencepoints_utm(4,1);
% y1=Referencepoints_utm(4,2);
x0=Section_coordinates(3,1);
y0=Section_coordinates(3,2);
x1=Section_coordinates(4,1);
y1=Section_coordinates(4,2);
ymin=min(Section_coordinates(3:4,2));
ymax=max(Section_coordinates(3:4,2));
[Xslice2,Yslice2,Zslice2,xslice2,yslice2]=deviatedslicelocation2points(x,z,x0,y0,x1,y1,ymax,ymin);
nzd=6/0.25+1;
ss=slice(X(:,:,1:nzd),Y(:,:,1:nzd),Z(:,:,1:nzd),Vsmean(:,:,1:nzd),Xslice2(1:nzd,:),Yslice2(1:nzd,:),Zslice2(1:nzd,:));
section2=ss.CData;
xs2=ss.XData(1,:);
ys2=ss.YData(1,:);
zs2=ss.ZData(:,1);
[E,N] = projfwd(p,ys2,xs2);
xs22=E/1000;
ys22=N/1000;
y0=(Referencepoints_utm(3,2)+Referencepoints_utm(4,2))/2;
x0=(Referencepoints_utm(3,1)+Referencepoints_utm(4,1))/2;
distanc0=sqrt((ys22(1)-y0).^2+(xs22(1)-x0).^2);
xsection2=sqrt((ys22-ys22(1)).^2+(xs22-xs22(1)).^2)-distanc0;

figure(111);
plot(xs2,ys2,'b')
hold on;plot([x0 x1],[y0 y1],'b','LineStyle','none','Marker','p')

%%


figure;
pcolor(xsection1,zs1*1000,section1);colorbar;colormap(jet);
axis ij;set(gca,'YDir','reverse','XDir','normal')
shading flat;shading interp
zlim([0 4])
title('Distance (km)');
% xlabel('Distance (km)');
ylabel('Depth (m)')
% cb=colorbar;
% cb.Label.String='Shear wave velocity (km/s)';
box(gca,'on');
set(gca,'FontSize',16,'FontWeight','bold','LineWidth',2,'TickDir','out')
% Create colorbar
colorbar(gca,'Position',...
    [0.91922738031721 0.111111111111111 0.0175592746432818 0.738011695906433]);

% Create textbox
annotation(gcf,'textbox',...
    [0.898040010033864 0.89185463659148 0.0610184372256364 0.0374269005847954],...
    'String',{'km/s'},...
    'LineStyle','none',...
    'FontWeight','bold',...
    'FontSize',18,...
    'FitBoxToText','off');

set(gca,'FontSize',16,'FontWeight','bold')
colormap(cmp);
% caxis(caxislim);
xlim(displaylimx)
ylim([-500 6000])
exportgraphics(gcf,'Figure11b.png');
saveas(gcf,'Figure11b.fig')
