%% Ploting chain statistics for noisy and noise free experiments....

clc;
clear
selpath = uigetdir('Select the path of the Log files of the MCTomo');
addpath(genpath(selpath));
addpath('../datafiles')
addpath('Functions')
%% Extracting Data From Log Files
inputparameters;
bmin=0;bmax=1.5;amin=0;amax=0.15;nmin=50;nmax=1200;
burnin=2000;
total_retained_samples=6000;
npost_burnin_samples=total_retained_samples-burnin;

ParallelTempering=false;
% Reading number of cells
ncell = cell(1,nchains);
for i = chains
    ncell{i}=dlmread([selpath,'/Results/resume/ncells_',num2str(i),'_ARD.txt']);
    %     ncell{i} = load(['Results/ncells_' num2str(i) '.dat']);
end
% Reading noise hyper parameters
for i=chains
    h=dlmread([selpath,'/Results/resume/Sampled_noise_hyperparameters_',num2str(i),'.txt']);
    a{i}=h(1:2:end,:);
    b{i}=h(2:2:end,:);
end
ExtractingDataFromLogFiles;

%% 
figure('Position',get(0,'screensize'))
%============================1=================
LogInfo.misfit{1, 4}(576)=LogInfo.misfit{1, 4}(575);
subplot(2,8,2:4);hold off
misfit_mean=0;
misfit_max=0;
misfit_min=max(max(LogInfo.misfit{i}));
for i= chains
    %     semilogy(misfit{i}(:,2),'LineWidth',3);
%     iterations2{i}=0:ndisplay:(length(LogInfo.misfit{i})-1)*ndisplay;
%     plot(iterations2{i},LogInfo.misfit{i},'LineWidth',3);
%     semilogy(iterations2{i},LogInfo.misfit{i},'LineWidth',3);
    semilogy([0;LogInfo.iteration{i}],LogInfo.misfit{i},'LineWidth',3);
    hold on;
    misfit_mean=misfit_mean+mean(LogInfo.misfit{i});
    misfit_min=min(misfit_min,min(LogInfo.misfit{i}));
    misfit_max=max(misfit_max,max(LogInfo.misfit{i}));
end
misfit_mean=misfit_mean/length(chains);
set(gca,'fontsize',14);
xlabel('Samples');
ylabel('Misfit');
title('(a)')
set(gca,'FontSize',16,'FontWeight','bold')

% box off
%============================2=================
subplot(2,8,6:8);hold off
for i= chains
    nsamples=length(ncell{i});
    iterations{i}=1:run_time_step:nsamples*run_time_step;
    plot(iterations{i},ncell{i},'LineWidth',3);
    hold on;
end
set(gca,'fontsize',14);
xlabel('Samples');
% ylabel('Number of cells')
title('(b)')
ylim([nmin nmax])
% box off;
yticks([]);%ax = gca;ax.YColor = 'w';
set(gca,'FontSize',16,'FontWeight','bold')

subplot(2,8,5);
ncell4histogram=zeros(npost_burnin_samples,length(chains));
for i= chains
    ncell4histogram(1:length(ncell{1,i})-burnin,i)=ncell{1,i}(burnin+1:end,1);
end
ncell4histogram=ncell4histogram(:);
ncell4histogram(ncell4histogram==0)=[];
nBins = 300;
sampleBins = linspace(nmin,nmax,nBins);
counts = hist(ncell4histogram(:), sampleBins);
barh(sampleBins,counts/sum(counts), 'b');
xlabel('Probability');
ylabel('Number of cells');
ylim([nmin nmax])
set(gca,'FontSize',16,'FontWeight','bold')

% box off
%============================3=================
subplot(2,8,10:12);hold off
for i= chains
    iter=1:run_time_step:length(a{1,i}(:,1))*run_time_step;
    plot(iter,a{1,i}(:,1),'LineWidth',3);
%     plot(iterations{i}(1:length(a{1,i}(:,1))),a{1,i}(:,1),'LineWidth',3);
    hold on;
    maxiter(i)=max(iterations{i});
end
maxiter=max(maxiter);


% plot(1:maxiter,ones(1,maxiter)*atrue,'k','LineWidth',3);
set(gca,'fontsize',14);
xlabel('Samples');
% ylabel('Noise hyper-parameter a');
title('(c)')
ylim([amin amax])
yticks([]);
set(gca,'FontSize',16,'FontWeight','bold')

subplot(2,8,9);
a4histogram=zeros(npost_burnin_samples,length(chains));
for i= chains
    a4histogram(1:length(ncell{1,i})-burnin,i)=a{1,i}(burnin+1:end,1);
end
a4histogram=a4histogram(:);
a4histogram(a4histogram==0)=[];

nBins = 300;
sampleBins = linspace(amin,amax,nBins);
counts = hist(a4histogram(:), sampleBins);
barh(sampleBins,counts/sum(counts), 'b');
xlabel('Probability');
ylabel('Noise hyper-parameter a');
set(gca,'FontSize',16,'FontWeight','bold')

%============================4=================

subplot(2,8,14:16);hold off
for i= chains
    iter=1:run_time_step:length(b{1,i}(:,1))*run_time_step;
    plot(iter,b{1,i}(:,1),'LineWidth',3);
%     plot(iterations{i}(1:length(a{1,i}(:,1))),b{1,i}(:,1),'LineWidth',3);
    hold on;
end
% plot(1:maxiter,ones(1,maxiter)*btrue,'k','LineWidth',3);
set(gca,'fontsize',14);
xlabel('Samples');
% ylabel('Noise hyper-parameter b');
title('(d)')
ylim([bmin bmax])
yticks([]);
set(gca,'FontSize',16,'FontWeight','bold')

subplot(2,8,13);
b4histogram=zeros(npost_burnin_samples,length(chains));
for i= chains
    b4histogram(1:length(ncell{1,i})-burnin,i)=b{1,i}(burnin+1:end,1);
end
b4histogram=b4histogram(:);
b4histogram(b4histogram==0)=[];
nBins = 300;
sampleBins = linspace(bmin,bmax,nBins);
counts = hist(b4histogram(:), sampleBins);
barh(sampleBins,counts/sum(counts), 'b');
xlabel('Probability');
ylabel('Noise hyper-parameter b');
pause(1)
set(gca,'FontSize',16,'FontWeight','bold')
%% 
exportgraphics(gcf,'Figure4.png')
saveas(gcf,'Figure4.fig')