% Read_Plot
clc;clear;close all
% UTM_latlong=0;% 1 means utm else geographical
mean_or_uncertainty=1;% 1 plots mean, with other values plots uncertainty
addpath('../datafiles')
addpath('Functions')
inputparameters_filename='inputparameters';
run(inputparameters_filename);
if mean_or_uncertainty==1
    displaylimitx=[-22.8 -21.9];
    displaylimity=[63.75 64.1];
else
    displaylimitx=[xmin xmax];
    displaylimity=[ymin ymax];
end
p = projcrs(32227);% WGS 72 / UTM zone 27N
[E,N] = projfwd(p,displaylimity,displaylimitx); % Project latitude-longitude coordinates to x-y map coordinates
latrange=abs(diff(displaylimity));
lonrange=abs(diff(displaylimitx));
xrange=abs(diff(E))/1000;
yrange=abs(diff(N))/1000;

load('stdS_Vsmean.mat');
%% Horizontal slices
ixmin=find(x>=displaylimitx(1),1);
ixmax=find(x>=displaylimitx(2),1);
iymin=find(y>=displaylimity(1),1);
iymax=find(y>=displaylimity(2),1);


% zprofile=[0.5,1,2,3,4,5,5.5,6,7,8,9,10,11,12,13,14,15,18];
zprofile=[0.5,3,4,6,8,10];
labels={'a','b','c','d','e','f','g','h','i','j','k','l','m','n','o','p'};
stdS_bkup=stdS;
eruptionlocation=[-22.27097300 -22.27060300 -22.26368000 -22.26816800 -22.26621600 -22.26889700 -22.26909300 -22.26760800 -22.26852800;63.888907 63.88921700 63.89517400 63.89208900 63.89337300 63.89100200 63.89056200 63.89279500 63.89053000];
% stdS=stdS.^2;
% figure('Position',get(0,'screensize'))
% adding scale bar
scal(1,1:2)=[-22.4,63.78];
[scaleE,scaleN] = projfwd(p,scal(1,2),scal(1,1));
scaleEnew=5000+scaleE;
[scal(2,2),scal(2,1)] = projinv(p,scaleEnew,scaleN);
scaleEnew=10000+scaleE;
[scal(3,2),scal(3,1)] = projinv(p,scaleEnew,scaleN);

for i=1:length(zprofile)
    figure('Position',get(0,'screensize'),'WindowStyle', 'docked')
    % % % if twoaxis==1
    % % %     % define a background axis to define on it the UTM coordinate
    % % %     ax1=axes('Box','off');
    % % %     set(ax1,'BoxStyle','full','TickDir','out','XAxisLocation','top','YAxisLocation','right');
    % % %     xlabel('Easting (km)');ylabel('Northing (km)')
    % % %     set(ax1,'Fontsize',16,'FontWeight','bold')
    % % %     daspect(ax1,[1 1 1]);
    % % %
    % % %     ax2=axes('Box','on');
    % % %     set(ax2,'Fontsize',16,'FontWeight','bold','TickDir','both','XMinorTick','on','YMinorTick','on')
    % % %     grid on
    % % %     box on
    % % % end


    Ploting_2D_HorizontalSlices(Vsmean,stdS,zprofile(i),inputparameters_filename,mean_or_uncertainty,displaylimitx,displaylimity);
    hold on;
    %     plot(eruptionlocation(1,:),eruptionlocation(2,:),'y','LineStyle','none','LineWidth',2,'Marker','*','MarkerSize',6)
    plot(mean(eruptionlocation(1,:)),mean(eruptionlocation(2,:)),'MarkerFaceColor',[1 1 0],'MarkerEdgeColor',[0 0 0],...
        'MarkerSize',25,...
        'Marker','pentagram',...
        'LineWidth',2,...
        'LineStyle','none',...
        'Color',[1 1 0]);
        % title(['(',labels{i},') '])
    ncmp=100;
    cmp = colormap(seismic(ncmp));
    cmp = flipud(cmp);
    colormap(cmp);


    xlim(displaylimitx);ylim(displaylimity);
    daspect(gca,[lonrange/xrange latrange/yrange 1]);
    % pbaspect(ax2,[xrange yrange 1]);
    iz=floor(zprofile(i)/dz)+1;
    if mean_or_uncertainty==1
        cplt=Vsmean(iymin:iymax,ixmin:ixmax,iz);cmin=min(cplt(:));cmax=max(cplt(:));
    else
        cplt=stdS(iymin:iymax,ixmin:ixmax,iz);cmin=min(cplt(:));cmax=max(cplt(:));
    end
    % add scale bar
    hold on;
    plot(scal(:,1),scal(:,2),'k','MarkerSize',15,'Marker','|','LineWidth',3,'LineStyle','-')
    text(scal(:,1)-0.01,scal(:,2)-0.008,{'0 km','5 km','10 km'},'FontSize',18)

    % Create colorbar
    cb=colorbar;
    if mean_or_uncertainty==1% mean
        cb.Label.String='Posterior mean (km/s)';
    else% uncertainty
        cb.Label.String='Uncertainty (km/s)';
    end
    set(cb,'Position',...
        [0.780789162442867 0.110336817653891 0.0126632185095141 0.638718974491332],...
        'LineWidth',1,...
        'FontWeight','bold',...
        'FontSize',26);

    % Create textbox
    annotation(gcf,'textbox',...
        [0.76989880952381 0.79537144577795 0.084267857142857 0.0479545747838415],...
        'String',{['Z = ',num2str(zprofile(i)),' km']},...
        'LineWidth',1,...
        'FontWeight','bold',...
        'FontSize',26,...
        'FitBoxToText','off',...
        'EdgeColor','none');
    set(gca,'Fontsize',26,'FontWeight','bold','TickDir','both','XMinorTick','on','YMinorTick','on','LineWidth',2)
    % set(gca,'Fontsize',26,'FontWeight','bold','XMinorTick','on','YMinorTick','on')
    clim([cmin cmax]);
    pause(0.5);
exportgraphics(gcf,['Figure5',labels{i},'.png']);
saveas(gcf,['Figure5',labels{i},'.fig'])
end
