% Read_Plot
% clc;clear;
addpath('data/MATLAB')
Referencepoints=[63.879 -22.433;63.825 -22.685; 63.918728 -22.091649]; 
Referencepoints=sortrows(Referencepoints,1);
nrp=2;% Eldvorp_Svartsnegi HT zone
eruptionlocation=[-22.27097300 -22.27060300 -22.26368000 -22.26816800 -22.26621600 -22.26889700 -22.26909300 -22.26760800 -22.26852800;63.888907 63.88921700 63.89517400 63.89208900 63.89337300 63.89100200 63.89056200 63.89279500 63.89053000];
Referencepoints=[Referencepoints;mean(eruptionlocation(2,:)) mean(eruptionlocation(1,:))];
yprofile=Referencepoints(nrp,1);
xprofile=Referencepoints(nrp,2);
plottype=1;% 1: imagesc, 2: contourf
% UTM_latlong=0;% 1 means utm else geographical
load('stdS_Vsmean.mat');
% inputparameters_filename=[selpath,'/inputparameters'];
inputparameters_filename='inputparameters';
%% reading source and receiver coordinates
run(inputparameters_filename);
xysrc=dlmread(['sources_LATLONG.dat']);
xyrcv=dlmread(['receivers_LATLONG.dat']);
nrcv=xyrcv(1,1);
xrcv=xyrcv(2:nrcv+1,2);
yrcv=xyrcv(2:nrcv+1,1);
nsrc=xysrc(1,1);
xsrc=xysrc(2:nsrc+1,2);
ysrc=xysrc(2:nsrc+1,1);
xlbl='Longitude';
ylbl='Latitude';
CoastX=CoastLonlat(:,1);
CoastY=CoastLonlat(:,2);
%% Vertical slices
figure('Position',get(0,'screensize'),'WindowStyle', 'docked');
mean_or_uncertainty=2;% 1 plots mean, with other values plots uncertainty


displaylimitx=[-22.9 -21.9];
displaylimity=[63.7 64.05];
% ncmp=20;
% cmp = colormap(seismic(ncmp));
% cmp = flipud(cmp);
% colormap(cmp)
%% EW vertical profile
subplot(222);
nyz=floor(abs(yprofile-ymin)/dy)+1;
if plottype==1
%     imagesc(x,z,squeeze(Vsmean(nyz,:,:))')
    pcolor(x,z,squeeze(Vsmean(nyz,:,:))');shading interp
else
    contourf(x,z,squeeze(Vsmean(nyz,:,:))');axis ij
end
% cb=colorbar;cb.Label.String='Posterior mean (km/s)';
% xlabel('Y (km)');
ylabel('Depth (km)');
xlabel(xlbl);
title('(b)')

text(displaylimitx(2),-1.0,'B''','HorizontalAlignment', 'center','FontSize',16,'FontWeight','bold');
text(displaylimitx(1),-1.0,'B','HorizontalAlignment', 'center','FontSize',16,'FontWeight','bold');
xlim(displaylimitx)

p = projcrs(32227);% WGS 72 / UTM zone 27N
[E,N] = projfwd(p,displaylimity,displaylimitx); % Project latitude-longitude coordinates to x-y map coordinates
latrange=abs(diff(displaylimity));
lonrange=abs(diff(displaylimitx));
xrange=abs(diff(E))/1000;
yrange=abs(diff(N))/1000;
% daspect([87.87018/111.045 20 87.87018 ]);
% daspect(gca,[lonrange/xrange latrange/yrange 1]);
daspect([1 xrange/lonrange 1])

hold on;
for i=1:size(Referencepoints,1)
    plot(Referencepoints(i,2)*ones(size(z)),z,'--g','LineWidth',3)
    if i~=4
    text(Referencepoints(i,2),-0.5,num2str(i),'HorizontalAlignment', 'center','FontSize',16,'FontWeight','bold');
    end
end

% cmp = colormap(seismic);
% cmp = flipud(cmp);
colormap(cmp);
nx1=find(x>=displaylimitx(1),1);
nx2=find(x>displaylimitx(2),1);
ny1=find(y>=displaylimity(1),1);
ny2=find(y>displaylimity(2),1);
vsmean2plot=Vsmean(ny1:ny2,nx1:nx2,:);
caxislim=[min(vsmean2plot(:)) max(vsmean2plot(:))];
clim(caxislim)
set(gca,'XDir','normal','YDir','reverse','YAxisLocation','left','FontSize',18,'FontWeight','bold','LineWidth',1)
%% NE-SW vertical profiles
% xy1=[x(1)*ones(length(y),1) flipud(y(:));x(:) y(1)*ones(length(x),1)];
% xy2=[x(:) y(end)*ones(length(x),1);x(end)*ones(length(y),1) flipud(y(:))];

%% 
p = projcrs(32227);% WGS 72 / UTM zone 27N
[E,N] = projfwd(p,Referencepoints(:,1),Referencepoints(:,2)); % Project latitude-longitude coordinates to x-y map coordinates

Referencepoints_utm(:,1)=E/1000;
Referencepoints_utm(:,2)=N/1000;

% [xutm,yutm]=utmxy();
plateboundary_direction=70;
theta=90-plateboundary_direction;
theta2=theta+90;
x0=Referencepoints_utm(nrp,1);
y0=Referencepoints_utm(nrp,2);

[Xslice,Yslice,Zslice,xslice,yslice]=deviatedslicelocation(x,xutm,y,yutm,theta,z,x0,y0,ymax,ymin);
[Xslice2,Yslice2,Zslice2,xslice2,yslice2]=deviatedslicelocation(x,xutm,y,yutm,theta2,z,x0,y0,ymax,ymin);

subplot(223);% N72E vertical profile
[X,Y,Z]=meshgrid(x,y,z);
ss=slice(X,Y,Z,Vsmean,Xslice,Yslice,Zslice);
% figure;contourf(ss.CData);axis ij;set(gca,'YDir','reverse');colormap(cmp);

% cb=colorbar;cb.Label.String='S-wave velocity posterior mean (km/s)';
% ncmp=100;
% % cmp = colormap(jet(ncmp));
% cmp = colormap(seismic(ncmp));
% cmp = flipud(cmp);
colormap(cmp);
clim(caxislim)
axis ij;set(gca,'ZDir','reverse','YDir','normal','LineWidth',1)
shading flat;shading interp
% hold on;plot3(xprofile*ones(size(z)),yprofile*ones(size(z)),z,'--g','LineWidth',3)
for i=1:size(Referencepoints,1)
    hold on;plot3(Referencepoints(i,2)*ones(size(z)),Referencepoints(i,1)*ones(size(z))-0.02,z,'--g','LineWidth',3)
    if i~=4
        text(Referencepoints(i,2),Referencepoints(i,1),-0.5,num2str(i),'HorizontalAlignment', 'center','FontSize',16,'FontWeight','bold');
    end
end
xlim(displaylimitx);ylim(displaylimity);
xlabel('Longitude');ylabel('Latitude');zlabel('Depth (km)')
set(gca,'FontSize',16,'FontWeight','bold')
title('(c)')
view(-10,35)

subplot(224);% N18W vertical profile
[X,Y,Z]=meshgrid(x,y,z);
slice(X,Y,Z,Vsmean,Xslice2,Yslice2,Zslice2);
% cb=colorbar;cb.Label.String='S-wave velocity posterior mean (km/s)';
% ncmp=100;
% % cmp = colormap(jet(ncmp));
% cmp = colormap(seismic(ncmp));
% cmp = flipud(cmp);
colormap(cmp);
axis ij;set(gca,'ZDir','reverse','YDir','normal','LineWidth',1)
shading flat;shading interp
% hold on;plot3(xprofile*ones(size(z)),yprofile*ones(size(z)),z,'--g','LineWidth',3)
for i=1:size(Referencepoints,1)
    hold on;plot3(Referencepoints(i,2)*ones(size(z)),Referencepoints(i,1)*ones(size(z)),z,'--g','LineWidth',3)
    if i~=4
    text(Referencepoints(i,2),Referencepoints(i,1),-0.5,num2str(i),'HorizontalAlignment', 'center','FontSize',16,'FontWeight','bold');
    end
end
xlim(displaylimitx);ylim(displaylimity);
xlabel('Longitude');ylabel('Latitude');zlabel('Depth (km)')
set(gca,'FontSize',16,'FontWeight','bold','LineWidth',1)
title('(d)');clim(caxislim)

%% =========== plotting geological features
subplot(2,2,1)
xlabel(xlbl);ylabel(ylbl);
title('(a)')
set(gca,'YDir','normal')
hold on;plot(CoastX,CoastY,'k','LineWidth',2)
hold on;plot(gca,Referencepoints(:,2),Referencepoints(:,1),'MarkerFaceColor','none','MarkerEdgeColor','k','MarkerSize',12,'Marker','v','LineStyle','none','LineWidth',3)
for ii=1:size(Referencepoints,1)-1
    text(gca,Referencepoints(ii,2),Referencepoints(ii,1),num2str(ii),'FontSize',30,'Color','black','HorizontalAlignment','left','VerticalAlignment','bottom')
end
%% Adding high temperature zones
load('HTzones.mat')
for i=1:length(S)
   hold on;h=plot(gca,S(i).X,S(i).Y,'k','LineStyle',':','LineWidth',3); 
end
hold on;plot(x,yprofile*ones(size(x)),'--b','LineWidth',3)
text(displaylimitx(2)+0.02,yprofile,'B''','HorizontalAlignment', 'center','FontSize',16,'FontWeight','bold');
text(displaylimitx(1)-0.02,yprofile,'B','HorizontalAlignment', 'center','FontSize',16,'FontWeight','bold');
plot(xslice,yslice,'--b','LineWidth',3)
text(displaylimitx(2)+0.02,yslice(find(xslice>displaylimitx(2),1)),'C''','HorizontalAlignment', 'center','FontSize',16,'FontWeight','bold');
text(displaylimitx(1)-0.02,yslice(find(xslice>displaylimitx(1),1)),'C','HorizontalAlignment', 'center','FontSize',16,'FontWeight','bold');
plot(xslice2,yslice2,'--b','LineWidth',3)
text(xslice2(find(yslice2<displaylimity(2),1)),displaylimity(2)+0.01,'D','HorizontalAlignment', 'center','FontSize',16,'FontWeight','bold');
text(xslice2(find(yslice2<displaylimity(1),1)),displaylimity(1)-0.01,'D''','HorizontalAlignment', 'center','FontSize',16,'FontWeight','bold');
xlim(displaylimitx);ylim(displaylimity);

hold on;
scal(1,1:2)=[-22.4,63.75];
[scaleE,scaleN] = projfwd(p,scal(1,2),scal(1,1));
scaleEnew=5000+scaleE;
[scal(2,2),scal(2,1)] = projinv(p,scaleEnew,scaleN);
scaleEnew=10000+scaleE;
[scal(3,2),scal(3,1)] = projinv(p,scaleEnew,scaleN);
plot(scal(:,1),scal(:,2),'k','MarkerSize',15,'Marker','|','LineWidth',3,'LineStyle','-')
xlim(displaylimitx);ylim(displaylimity);
text(scal(:,1)-0.01,scal(:,2)-0.015,{'0 km','5 km','10 km'})
box on  
set(gca,'YAxisLocation','left','FontSize',16,'FontWeight','bold','LineWidth',1)
cb=colorbar;cb.Label.String='Posterior mean (km/s)';
set( cb, 'YDir', 'reverse','Position',...
    [0.494226323385088 0.333332292961352 0.00952380952380943 0.340909090909091] );
% cmp = colormap(seismic);
% cmp = flipud(cmp);
colormap(cmp);
clim(caxislim)
daspect(gca,[lonrange/xrange latrange/yrange 1]);

subplot(223);hold on; 
text(displaylimitx(2)+0.02,yslice(find(xslice>displaylimitx(2),1)),0,'C''','HorizontalAlignment', 'center','FontSize',16,'FontWeight','bold');
text(displaylimitx(1)-0.02,yslice(find(xslice>displaylimitx(1),1)),0,'C','HorizontalAlignment', 'center','FontSize',16,'FontWeight','bold');
subplot(224);hold on;
text(xslice2(find(yslice2<displaylimity(2),1)),displaylimity(2)+0.01,0,'D','HorizontalAlignment', 'center','FontSize',16,'FontWeight','bold');
text(xslice2(find(yslice2<displaylimity(1),1)),displaylimity(1)-0.01,0,'D''','HorizontalAlignment', 'center','FontSize',16,'FontWeight','bold');

%% Eruption location
subplot(221);hold on;
plot(mean(eruptionlocation(1,:)),mean(eruptionlocation(2,:)),'MarkerFaceColor',[1 1 0],'MarkerEdgeColor',[0 0 0],...
    'MarkerSize',25,'Marker','pentagram','LineWidth',2,'LineStyle','none','Color',[1 1 0]);
subplot(222);hold on;
plot(mean(eruptionlocation(1,:)),0,'MarkerFaceColor',[1 1 0],'MarkerEdgeColor',[0 0 0],...
    'MarkerSize',25,'Marker','pentagram','LineWidth',2,'LineStyle','none','Color',[1 1 0]);

subplot(223);hold on;
plot3(mean(eruptionlocation(1,:)),mean(eruptionlocation(2,:)),0,'MarkerFaceColor',[1 1 0],'MarkerEdgeColor',[0 0 0],...
    'MarkerSize',25,'Marker','pentagram','LineWidth',2,'LineStyle','none','Color',[1 1 0]);
subplot(224);hold on;
plot3(mean(eruptionlocation(1,:)),mean(eruptionlocation(2,:)),0,'MarkerFaceColor',[1 1 0],'MarkerEdgeColor',[0 0 0],...
    'MarkerSize',25,'Marker','pentagram','LineWidth',2,'LineStyle','none','Color',[1 1 0]);

colormap(cmp);

exportgraphics(gcf,'Figure8_updated.png')
saveas(gcf,'Figure8_updated.fig')
