% Read_Plot
clc;clear;close all
% UTM_latlong=0;% 1 means utm else geographical
mean_or_uncertainty=0;% 1 plots mean, with other values plots uncertainty
addpath('../datafiles')
addpath('Functions')
inputparameters_filename='inputparameters';
run(inputparameters_filename);
if mean_or_uncertainty==1
    displaylimitx=[-22.8 -21.9];
    displaylimity=[63.75 64.1];
else
    displaylimitx=[-23.5 xmax];
    displaylimity=[63.6 ymax];
end
p = projcrs(32227);% WGS 72 / UTM zone 27N
[E,N] = projfwd(p,displaylimity,displaylimitx); % Project latitude-longitude coordinates to x-y map coordinates
latrange=abs(diff(displaylimity));
lonrange=abs(diff(displaylimitx));
xrange=abs(diff(E))/1000;
yrange=abs(diff(N))/1000;

load('stdS_Vsmean.mat');
stdS=real(stdS);
%% Horizontal slices
ixmin=find(x>=displaylimitx(1),1);
ixmax=find(x>=displaylimitx(2),1);
iymin=find(y>=displaylimity(1),1);
iymax=find(y>=displaylimity(2),1);


% zprofile=[0.5,2,3,4,5.5,7,9];
zprofile=[0.5,3,4,6,8,10];
labels={'a','b','c','d','e','f'};
stdS_bkup=stdS;
eruptionlocation=[-22.27097300 -22.27060300 -22.26368000 -22.26816800 -22.26621600 -22.26889700 -22.26909300 -22.26760800 -22.26852800;63.888907 63.88921700 63.89517400 63.89208900 63.89337300 63.89100200 63.89056200 63.89279500 63.89053000];
% stdS=stdS.^2;
% figure('Position',get(0,'screensize'))
% adding scale bar
scal(1,1:2)=[-22,63.65];
[scaleE,scaleN] = projfwd(p,scal(1,2),scal(1,1));
scaleEnew=5000+scaleE;
[scal(2,2),scal(2,1)] = projinv(p,scaleEnew,scaleN);
scaleEnew=10000+scaleE;
[scal(3,2),scal(3,1)] = projinv(p,scaleEnew,scaleN);
scaleEnew=20000+scaleE;
[scal(4,2),scal(4,1)] = projinv(p,scaleEnew,scaleN);

for i=1:length(zprofile)
    figure('Position',get(0,'screensize'))
    Ploting_2D_HorizontalSlices(Vsmean,stdS,zprofile(i),inputparameters_filename,mean_or_uncertainty,displaylimitx,displaylimity);
    hold on;plot(eruptionlocation(1,:),eruptionlocation(2,:),'y','LineStyle','none','LineWidth',2,'Marker','+','MarkerSize',6)
    %     title(['(',labels{i},') '])
    ncmp=100;
    cmp = colormap(seismic(ncmp));
    %     cmp = flipud(cmp);
    colormap(cmp);
    
    
    xlim(displaylimitx);ylim(displaylimity);
    daspect(gca,[lonrange/xrange latrange/yrange 1]);
    % pbaspect(ax2,[xrange yrange 1]);
    iz=floor(zprofile(i)/dz)+1;
    if mean_or_uncertainty==1
        cplt=Vsmean(iymin:iymax,ixmin:ixmax,iz);cmin=min(cplt(:));cmax=max(cplt(:));
    else
        cplt=stdS(iymin:iymax,ixmin:ixmax,iz);cmin=min(cplt(:));cmax=max(cplt(:));
    end
    % add scale bar
    hold on;
    plot(scal(:,1),scal(:,2),'k','MarkerSize',15,'Marker','|','LineWidth',3,'LineStyle','-')
    text(scal(:,1)-0.01,scal(:,2)-0.02,{'0 km','5 km','10 km','20 km'},'FontSize',18,'FontWeight','bold')
    
    % Create colorbar
    cb=colorbar;
    if mean_or_uncertainty==1% mean
        cb.Label.String='Posterior mean (km/s)';
    else% uncertainty
        cb.Label.String='Uncertainty (km/s)';
    end
    set(cb,'Position',...
        [0.926622495776202 0.117305458768874 0.0126632185095141 0.638718974491332],...
        'LineWidth',1,...
        'FontWeight','bold',...
        'FontSize',26);
    
    % Create textbox
    annotation(gcf,'textbox',...
        [0.916922619047622 0.780272723362154 0.084267857142857 0.0479545747838415],...
        'String',{['Z = ',num2str(zprofile(i)),' km']},...
        'LineWidth',1,...
        'FontWeight','bold',...
        'FontSize',26,...
        'FitBoxToText','off',...
        'EdgeColor','none');
    set(gca,'Fontsize',26,'FontWeight','bold','TickDir','both','XMinorTick','on','YMinorTick','on')
    
    hold on
    displaylimitx2=[-22.8 -21.9];
    displaylimity2=[63.75 64.1];
    yplot=y(y>=displaylimity2(1));
    yplot=yplot(yplot<=displaylimity2(2));
    plot(displaylimitx2(1)*ones(size(yplot)),yplot,'--k','LineWidth',4)
    plot(displaylimitx2(2)*ones(size(yplot)),yplot,'--k','LineWidth',4)
    xplot=x(x>=displaylimitx2(1));
    xplot=xplot(xplot<=displaylimitx2(2));
    
    plot(xplot,displaylimity2(1)*ones(size(xplot)),'--k','LineWidth',4)
    plot(xplot,displaylimity2(2)*ones(size(xplot)),'--k','LineWidth',4)
    exportgraphics(gcf,['FigureB1',labels{i},'.png']);
saveas(gcf,['FigureB1',labels{i},'.fig'])
    
    pause(0.5);
    
end
