%% Extracting data from log files
% clc;clear;close all
% nchains=3;
% chains=1:nchains;
clear('LogInfo')
for i=chains
    MCTomolog=textread([selpath,'/Log/MCTomo_',num2str(i),'.log'],'%s');
    % Finding common values of misfit and number of cells if multiple runs have been performed
    index1 = find(strcmp(MCTomolog, 'Ranseed=')==1);
    index1(1)=[];
    if ~isempty(index1)
        for ii=1:length(index1)
            MCTomolog{index1(ii)+13}={};
            MCTomolog{index1(ii)+16}={};
        end
    end
    % Extracting misfit information
%     index = find(strcmp(MCTomolog, '-loglikelihood:')==1);
    index_1 = find(strcmp(MCTomolog, 'unweighted')==1);
    index_2 = find(strcmp(MCTomolog, 'Unweighted')==1);
    index=[index_1(1);index_2];
%     index = find(strcmp(MCTomolog, 'Weighted')==1);
    LogInfo.misfit{i}=str2double(MCTomolog(index+2));
    % Extracting Number of cells
    index = find(strcmp(MCTomolog, 'cells:')==1);
    LogInfo.ncells{i}=str2double(MCTomolog(index+1));
    % Extracting Iteration number
    index = find(strcmp(MCTomolog, 'Sample:')==1);
    for k=1:length(index)
        step=(MCTomolog(index(k)+1));
        step2=strsplit(step{1},'/');
        LogInfo.iteration{i}(k,1)=str2num(step2{1});
    end
%     diffLofInfoIteri=diff(LogInfo.iteration{i});
    LogInfo.iteration_bk=LogInfo.iteration{i};
    addition=0;
    for k=2:length(index)
        
        if LogInfo.iteration_bk(k,1)<LogInfo.iteration_bk(k-1,1)
            addition=LogInfo.iteration{i}(k-1,1);
            LogInfo.iteration{i}(k,1)=LogInfo.iteration{i}(k,1)+addition;
        else
            LogInfo.iteration{i}(k,1)=LogInfo.iteration{i}(k,1)+addition;
        end
    end
    % Extracting Acceptance ratios
    index = find(strcmp(MCTomolog, 'ARV')==1);
    LogInfo.ARV1{i}=str2double(MCTomolog(index(1:2:end)+1));
    LogInfo.ARV2{i}=str2double(MCTomolog(index(2:2:end)+1));
    index = find(strcmp(MCTomolog, 'ARP')==1);
    LogInfo.ARP1{i}=str2double(MCTomolog(index(1:2:end)+1));
    LogInfo.ARP2{i}=str2double(MCTomolog(index(2:2:end)+1));
    index = find(strcmp(MCTomolog, 'ARB')==1);
    LogInfo.ARB1{i}=str2double(MCTomolog(index(1:2:end)+1));
    LogInfo.ARB2{i}=str2double(MCTomolog(index(2:2:end)+1));
    index = find(strcmp(MCTomolog, 'ARD')==1);
    LogInfo.ARD1{i}=str2double(MCTomolog(index(1:2:end)+1));
    LogInfo.ARD2{i}=str2double(MCTomolog(index(2:2:end)+1));
    index = find(strcmp(MCTomolog, 'ARS')==1);
    LogInfo.ARS_body{i}=str2double(MCTomolog(index(1:3:end)+1));
    LogInfo.ARS_surf{i}=str2double(MCTomolog(index(2:3:end)+1));
    LogInfo.ARS_srcloc{i}=str2double(MCTomolog(index(3:3:end)+1));
if ParallelTempering
       index = find(strcmp(MCTomolog, 'Temperature:')==1);
        LogInfo.Temperature{i}=str2double(MCTomolog(index+1));

end

end
