function Ploting_2D_HorizontalSlices_contourf(Vsmean,stdS,zprofile,inputparameters_filename,mean_or_uncertainty,displaylimitx,displaylimity)
UTM_latlong=0;
%% reading source and receiver coordinates
run(inputparameters_filename);
xysrc=dlmread(['sources_LATLONG.dat']);
xyrcv=dlmread(['receivers_LATLONG.dat']);
nrcv=xyrcv(1,1);
xrcv=xyrcv(2:nrcv+1,2);
yrcv=xyrcv(2:nrcv+1,1);
nsrc=xysrc(1,1);
xsrc=xysrc(2:nsrc+1,2);
ysrc=xysrc(2:nsrc+1,1);
xlbl='Longitude';
ylbl='Latitude';
CoastX=CoastLonlat(:,1);
CoastY=CoastLonlat(:,2);

if mean_or_uncertainty==1% plotting mean
    nz_hslice=floor(zprofile/dz)+1;
    contourf(x,y,squeeze(Vsmean(:,:,nz_hslice)),'ShowText','on');axis equal;axis tight
    cb=colorbar;
%     cb.Label.String='S-wave velocity posterior mean (km/s)';
    cb.Label.String='Posterior mean (km/s)';
    xlabel('X (km)');ylabel('Y (km)');
    xlabel(xlbl);ylabel(ylbl);title('Top view')
    title('(a) Mean velocity')
    % hold on;plot(x,yprofile*ones(size(x)),'--k','LineWidth',3)
    % text(displaylimitx(1)-0.02,yprofile,'A','HorizontalAlignment', 'center');
    % text(displaylimitx(2)+0.02,yprofile,'A''','HorizontalAlignment', 'center');
    % hold on;plot(xrcv,yrcv,'MarkerSize',10,'Marker','v','MarkerFaceColor','none','MarkerEdgeColor','w','LineStyle','none','LineWidth',2);
    hold on;plot(CoastX,CoastY,'k','LineWidth',2)
    hold on;addGeologicalsettings(UTM_latlong);
    ncmp=20;
    % cmp = colormap(seismic(ncmp));
    cmp = colormap(jet(ncmp));
    cmp = flipud(cmp);
    colormap(cmp);
    xlim(displaylimitx);ylim(displaylimity);
    if UTM_latlong==1% utm
        %     axis equal;axis tight;
        %     daspect([1 1 1])
        
    else
        % One degree of latitude equals approximately 111.045 km
        % One-degree of longitude equals 87.87018 km
        daspect([1.6 87.87018/111.045 87.87018/3]);
    end
    set(gca,'YDir','normal','FontSize',16,'FontWeight','bold')
    
    % subplot(122)
else% plotting uncertainty
    nz_hslice=floor(zprofile/dz)+1;
    contourf(x,y,squeeze(stdS(:,:,nz_hslice)));axis equal;axis tight
    cb=colorbar;cb.Label.String='Posterior standard deviation (km/s)';
    xlabel('X (km)');ylabel('Y (km)');
    xlabel(xlbl);ylabel(ylbl);title('Top view')
    title('(b) uncertainty')
    % hold on;plot(x,yprofile*ones(size(x)),'--k','LineWidth',3)
    % text(displaylimitx(1)-0.02,yprofile,'A','HorizontalAlignment', 'center');
    % text(displaylimitx(2)+0.02,yprofile,'A''','HorizontalAlignment', 'center');
    hold on;plot(xrcv,yrcv,'MarkerSize',10,'Marker','v','MarkerFaceColor','none','MarkerEdgeColor','w','LineStyle','none','LineWidth',2);
    hold on;plot(CoastX,CoastY,'k','LineWidth',2)
    hold on;addGeologicalsettings(UTM_latlong);
    
end
cmp = colormap(jet(ncmp));
% cmp = colormap(seismic(ncmp));
cmp = flipud(cmp);
colormap(cmp);
xlim(displaylimitx);ylim(displaylimity);
if UTM_latlong==1% utm
    %     axis equal;axis tight;
    %     daspect([1 1 1])
    
else
    % One degree of latitude equals approximately 111.045 km
    % One-degree of longitude equals 87.87018 km
    daspect([1.6 87.87018/111.045 87.87018/3]);
end
set(gca,'YDir','normal','FontSize',16,'FontWeight','bold')

end