function [Interpolated_vels,TT]=ResamplingDCs(PickedCurve,freq2invert,fmax,nwavelength2discard)
discr_vels=PickedCurve.discr_vels;
discr_freqs=PickedCurve.discr_freqs;
x=discr_freqs;
y=discr_vels;
i2r=find(x>fmax);
x(i2r)=[];
y(i2r)=[];
[C,ia,ic] = unique(x);
x=x(ia);y=y(ia);
[fitresult, gof] = createFit_fre_TT(x,y);
Interpolated_vels=fitresult(freq2invert);
DIST=PickedCurve.DIST;
vv=Interpolated_vels;
% Removing extrapolated points in the high frequency part
vv(freq2invert(:)>max(discr_freqs(:)))=0;
% Removing extrapolated points in the low frequency part
vv(freq2invert(:)<min(discr_freqs(:)))=0;
% Removing extrapolated points in the low frequency part
vv(nwavelength2discard*Interpolated_vels(:)./freq2invert(:)>DIST)=0;
i2invert=find(vv>0);
% Removing extrapolated points in the high frequency part
%                     i2=find(freq2invert(:)<=max(discr_freqs(:)));
%                     vv2=vv(i2);freq2invert2=freq2invert(i2);
% Removing points that generates wavelength higher than the limit
%                     i3=find(nwavelength2discard*vv2(:)./freq2invert2(:)<=DIST);
%                     vv3=vv2(i3);freq2invert3=freq2invert2(i3);
% Removing extrapolated points in the low frequency part
%                     i2invert=find(freq2invert3(:)>=min(discr_freqs(:)));
%                 i2=find(nwavelength2discard*Interpolated_vels(:)./freq2invert(:)<=DIST);
%                 i2invert=find(freq2invert(i2)<=max(x(:)));
TT=zeros(size(freq2invert))-1;
TT(i2invert)=DIST./Interpolated_vels(i2invert);

end

function [fitresult, gof] = createFit_fre_TT(x, y)
%CREATEFIT(X,Y)
%  Create a fit.
%
%  Data for 'untitled fit 1' fit:
%      X Input : x
%      Y Output: y
%  Output:
%      fitresult : a fit object representing the fit.
%      gof : structure with goodness-of fit info.
%
%  See also FIT, CFIT, SFIT.

%  Auto-generated by MATLAB on 01-Nov-2020 22:50:18


%% Fit: 'untitled fit 1'.
[xData, yData] = prepareCurveData( x, y );

% Set up fittype and options.
% ft = 'pchipinterp'; % Shape-preserving piecewise cubic Hermite (pchip) interpolation 
ft = 'cubicinterp'; % Cubic spline interpolation
% ft = 'linearinterp'; % Linear interpolation 

% Fit model to data.
[fitresult, gof] = fit( xData, yData, ft, 'Normalize', 'on' );

% Plot fit with data.
% % figure( 'Name', 'untitled fit 1' );
% % h = plot( fitresult, xData, yData );
% % legend( h, 'y vs. x', 'untitled fit 1', 'Location', 'NorthEast' );
% % % Label axes
% % xlabel x
% % ylabel y
% % grid on


end